local entity_names_list = {'nuclear-entity'}

script.on_init(function(data)
  if not global then global = {} end
  if not global.entities then global.entities = {} end
  if not global.tick_id then global.tick_id = 1 end
  if not global.amount_entities then global.amount_entities = 0 end
end)

script.on_event(defines.events.on_built_entity, function(event)
  for j, entity_name in pairs (entity_names_list) do
    if	(event.created_entity.name == entity_name) then 
      onBuildHandler(event) 
    end
  end
end)

script.on_event(defines.events.on_robot_built_entity, function(event)
  for j, entity_names in pairs (entity_names_list) do
    if	(event.created_entity.name == entity_names) then 
      onBuildHandler(event) 
    end
  end
end)

function onBuildHandler(event) 
  local entity = event.created_entity
  table.insert(global.entities, entity)
  global.amount_entities = global.amount_entities + 1
end

script.on_event(defines.events.on_tick, function(event)
  if global.amount_entities == 0 then return end
  local tick_id = global.tick_id
  if tick_id > global.amount_entities then
    tick_id = 1
  end
  
  local entity = global.entities[tick_id]
  if not (entity and entity.valid) then -- remove this element from tha table and return
    table.remove(global.entities, tick_id)
    global.amount_entities = global.amount_entities - 1
    return
  end
  
  global.tick_id = tick_id + 1
  
  local signals = entity.get_merged_signals()
  if signals then
    for i, case in pairs (signals) do
      local signal = case.signal
      if signal and (signal.name == 'atomic-bomb') then
        --explosion!
        local surface = entity.surface
        local position = entity.position
        
        -- surface.create_entity{name='big-boom-atomic-explosion', position=position}
        -- surface.create_entity{name='big-boom-atomic-explosion', position=position, target=entity, speed =0.1 }
        -- surface.create_entity{name='atomic-rocket', position=position, target=entity, speed =0 }
        surface.create_entity{name='big-boom-atomic-explosion', position=position, target=entity, speed =0 }
        
        -- entity.die()
        return
      end
    end
  end
end)













